/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *    XMMP - X MultiMedia Project					     *
 *    This Code is Copyright (c) 1999, 2000 by Arthur Kleer		     *
 *    All rights reserved.						     *
 *    								             *
 *    See COPYING in the main source dir for more details.		     *
 *								             *
 *    For contact, mail to: 'xmmp@frozenproductions.com'	             *
 *    Visit our Homepage: http://www.frozenproductions.com                   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef INC_mplayer_h
#define INC_mplayer_h

#include <gtk/gtk.h>

#include "support.h"

#include "skin_draw.h"
#include "skin_list.h"
#include "skin_menu.h"
#include "skin_number.h"
#include "skin_pbutton.h"
#include "skin_pixmap.h"
#include "skin_popup.h"
#include "skin_slider.h"
#include "skin_status.h"
#include "skin_tbutton.h"
#include "skin_textbox.h"

#include "mplayertypes.h"

//
// Definitions
//

#define	MPLAYER_FILESEL_OK		1
#define	MPLAYER_FILESEL_SELECT		2

#define	MPLAYER_DIRSEL_ISFILE		128

#define	MPLAYER_FILESEL_BUTTONS		1	// Show select buttons
#define	MPLAYER_DIRSEL_GETFILES		1	// return files instead of dir

//
// Prototypes
//

int	mplayer_LoadTheme( char *theme, char *skin, Theme *tdesc );
void	mplayer_FreeTheme( Theme *tdesc );
void	mplayer_InitThemeWindows( Theme *tdesc, int state );
void	mplayer_WidgetDrawAll( Theme *tdesc );
void	mplayer_WidgetVisible( void *w, int state );

void	*mplayer_ButtonPress( Theme *theme, GdkEventButton *event );
void	*mplayer_ButtonRelease( Theme *theme, GdkEventButton *event );
void	mplayer_Motion( Theme *theme, GdkEventButton *event );

void	mplayer_Message( char *label, char *text );
void	mplayer_FileSelect( int mode, char *path, void (*_LoadDialogCallback)( char *filename, int mode ));
void	mplayer_DirSelect( int mode, void (*_LoadDialogCallback)( char *path, int mode ));
void	mplayer_UrlSelect( GList *url_history, void (*_LoadDialogCallback)( char *url ));
void	mplayer_SkinBrowser( void );

#endif
