/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *    XMMP - X MultiMedia Project					     *
 *    This Code is Copyright (c) 1999, 2000 by Arthur Kleer		     *
 *    All rights reserved.						     *
 *    								             *
 *    See COPYING in the main source dir for more details.		     *
 *								             *
 *    For contact, mail to: 'xmmp@frozenproductions.com'	             *
 *    Visit our Homepage: http://www.frozenproductions.com                   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef INC_mplayertypes_h
#define INC_mplayertypes_h

#include <gtk/gtk.h>

typedef struct _Widget		Widget;
typedef struct _WidgetTable	WidgetTable;
typedef struct _Theme		Theme;

//
// Widget. Common to all widgets
//

struct _Widget
{
    GdkWindow	*window;	// Target Drawable
    GdkGC	*gc;		// Graphic context of the target drawble
    GdkPixmap	*pixmap;	// Pixmap with source data
    GdkBitmap	*mask;		// ??? is it really used ?
    Theme	*theme;
    int		x;
    int		y;
    int		width;
    int		height;
    int		visible;
    void	(*cbDraw)( struct _Widget *widget );
    int		(*cbButtonPress)( GtkWidget *gtkwidget, GdkEventButton *event, struct _Widget *widget );
    int		(*cbButtonRelease)( GtkWidget *gtkwidget, GdkEventButton *event, struct _Widget *widget );
    int		(*cbMotion)( GtkWidget *gtkwidget, GdkEventButton *event, struct _Widget *widget );
// Callbacks
    void	(*ChangeCallback)( int value );
    void	(*ReleaseCallback)( int value );
// Free widget
    void	(*Free)( struct _Widget *widget );
};

//
// WidgetTable.
//

struct _WidgetTable
{
    char	name[256];
    Widget	**pWidget;

// Internal
    char	pixmapfile[256];
    GdkPixmap	*pixmap;
    GdkPixmap	*pixmap_ds;

// Default pixmap
    char	**defpixmap;

// Callbacks
    void	(*ReleaseCallback)( int value );
    void	(*ChangeCallback)( int value );
};

//
// Theme. Needed by LoadTheme
//

struct _Theme
{
    WidgetTable	*wtable;
    int		wnum;
    char	section[64];
    char	**skin_def;		// We need this indirection
    GtkWidget	**window;		// to make Pre-Initialization
    GList	**wlist;		// possible
    int		EnableDouble;
    void	(*cbRefreshTheme)( char *theme, char *skin );
// Internal
    GdkPixmap	*pixmap;
    GdkBitmap	*mask_ds;
    GdkGC	*gc;
};

#endif
