/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *    XMMP - X MultiMedia Project					     *
 *    This Code is Copyright (c) 1999, 2000 by Arthur Kleer		     *
 *    All rights reserved.						     *
 *    								             *
 *    See COPYING in the main source dir for more details.		     *
 *								             *
 *    For contact, mail to: 'xmmp@frozenproductions.com'	             *
 *    Visit our Homepage: http://www.frozenproductions.com                   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef INC_skin_list_h
#define INC_skin_list_h

#include "mplayertypes.h"
#include "skin_widget.h"

//
// Definitions
//

#define	LIST_DOUBLE_CLICK	32768

//
// Types
//

typedef struct _wListEntry
{
    char	*text;
    int		selected;
} wListEntry;

typedef struct _wList
{
    Widget	sys;
    GdkColor	color, color_h;
    GdkColor	bgcolor, bgcolor_h;
    int		fheight;
    int		active;
    int		selected;
    int		pressed;
    int		start;
    GList	*elist;
} wList;

//
//
//

Widget	*wListParse( int mode, char *option, char *value );

int	wListAddEntry( wList *list, char *text );
void	wListClear( wList *list );
void	wListSetActive( wList *list, int active );
void	wListRemove( wList *list, int num );

int	wListSelectionGet( wList *list, int nth );
int	wListSelectionSet( wList *list, int nth, int flag );

#endif
