/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *    XMMP - X MultiMedia Project					     *
 *    This Code is Copyright (c) 1999, 2000 by Arthur Kleer		     *
 *    All rights reserved.						     *
 *    								             *
 *    See COPYING in the main source dir for more details.		     *
 *								             *
 *    For contact, mail to: 'xmmp@frozenproductions.com'	             *
 *    Visit our Homepage: http://www.frozenproductions.com                   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef INC_config_h
#define INC_config_h

#include "klist.h"

typedef struct _ConfigLine
{
    char	*name;
    char	*value;
} ConfigLine;

typedef struct _ConfigSection
{
    char	*name;
    KList	*lines;
} ConfigSection;

typedef struct _ConfigFile
{
    KList	*sections;
} ConfigFile;

//
// User config
//

#define	CFG_TYPE_INT	1
#define	CFG_TYPE_STRING	2
#define	CFG_TYPE_BOOL	3
#define	CFG_TYPE_DOUBLE	4

#define	CFG_TYPE_STRING_LIST	6

typedef struct _UserConfig
{
    void	*ptr;
    char	name[256];
    int		type;
} UserConfig;

int cfg_LoadUserConfig( char *filename, char *section, UserConfig *ucfg );
int cfg_SaveUserConfig( char *filename, char *section, UserConfig *ucfg );

//
//
//

ConfigFile	*cfg_New( void );
void		cfg_Free( ConfigFile *cfg );
void		cfg_Remove( ConfigFile *cfg, char *secname, char *name );

ConfigFile	*cfg_ReadFile( char *filename );
int		cfg_WriteFile( ConfigFile *cfg, char *filename );

int cfg_ReadString( ConfigFile *cfg, char *secname, char *name, char *value );
int cfg_ReadInt( ConfigFile *cfg, char *secname, char *name, int *value );
int cfg_ReadBool( ConfigFile *cfg, char *secname, char *name, int *value );
int cfg_ReadDouble( ConfigFile *cfg, char *secname, char *name, double *value );

int cfg_WriteString( ConfigFile *cfg, char *secname, char *name, char *value );
int cfg_WriteInt( ConfigFile *cfg, char *secname, char *name, int value );
int cfg_WriteBool( ConfigFile *cfg, char *secname, char *name, int value );
int cfg_WriteDouble( ConfigFile *cfg, char *secname, char *name, double value );

#endif
